#!/usr/bin/perl

my $default_txt = "syslinux-default.txt";
my $lock_txt = "syslinux-lock.txt";
if (@ARGV > 0) {
    $default_txt = $ARGV[0]."/$default_txt";
    $lock_txt = $ARGV[0]."/$lock_txt";
}

my $template = '
/* originaly generated by exo-csource */
/* automatically generated from syslinux-default.txt */
#ifdef __SUNPRO_C
#pragma align 4 (default_syscfg)
#endif
#ifdef __GNUC__
const char default_syscfg[] __attribute__ ((__aligned__ (4))) =
#else
const char default_syscfg[] =
#endif
{
DEFAULT
};

/* automatically generated from syslinux-lock.txt */
#ifdef __SUNPRO_C
#pragma align 4 (locked_syscfg)
#endif
#ifdef __GNUC__
const char locked_syscfg[] __attribute__ ((__aligned__ (4))) =
#else
const char locked_syscfg[] =
#endif
{
LOCK
};
';

open FD, $default_txt;
my $default_str = "";
while (<FD>) {
    chomp; $default_str .= "  \"$_\\n\"\n";
}
close FD;
open FD, $lock_txt;
my $lock_str = "";
while (<FD>) {
    chomp; $lock_str .= "  \"$_\\n\"\n";
}
close FD;

$template =~ s/DEFAULT/$default_str/;
$template =~ s/LOCK/$lock_str/;

print $template;
